# Copyright (C) 2006-2008 by Sergio Pistone
#  sergio_pistone@yahoo.com.ar
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

$LOAD_PATH << File.expand_path(File.dirname(__FILE__))

require "lyrics"

class Sing365 < Lyrics

	def Sing365.site_host()
		return "www.sing365.com"
	end

	def Sing365.site_name()
		return "Sing365"
	end

	def Sing365.get_test_data()
		return [
			{ "artist"=>"Nirvana", "album"=>"Nevermind", "title"=>"Smells Like Teen Spirit" },
			{ "artist"=>"The Cranberries", "album"=>"Everybody Else Is Doing It, So Why Can't We?", "title"=>"Linger" },
			{ "artist"=>"Pearl Jam", "album"=>"Ten", "title"=>"Porch" },
			{ "artist"=>"The Smashing Pumpkins", "album"=>"Siamese Dream", "title"=>"Mayonaise" },
		]
	end

	def Sing365.build_song_add_url( artist, title, album=nil, year=nil )
		return build_google_feeling_lucky_url( artist )
	end

	def build_lyrics_fetch_data( artist, title, album=nil, year=nil )
		return { "url" => build_google_feeling_lucky_url( artist, title ) }
	end

	def check_lyrics_page( page_body, artist, title, album=nil, year=nil )
		md = /<title>([^<]+) - ([^<]+) LYRICS<\/title>/.match( page_body )
		return md ?
			Strings.normalize( artist ) == Strings.normalize( md[1] ) &&
			Strings.normalize( title ) == Strings.normalize( md[2] ) :
			false
	end

	def parse_lyrics( url, body, artist, title, album=nil, year=nil )

		body.tr_s!( " \n\r\t", " " )

		lyrics_data = {}

		if ( md = /<meta name="Description" content="([^"]+) lyrics performed by ([^"]+)">/.match( body ) )
			lyrics_data["artist"], lyrics_data["title"] = md[1], md[2]
		end

		return lyrics_data if ( ! (md = /<img src=http:\/\/#{site_host()}\/images\/phone2\.gif border=0><br><br><\/DIV>(.*)<DIV ALIGN=center><br><br><img src=http:\/\/#{site_host()}\/images\/phone\.gif/.match( body )) )

		lyrics_data["lyrics"] = md[1]
		lyrics_data["lyrics"].gsub!( /\ ?<br ?\/?> ?/i, "\n" )
		lyrics_data["lyrics"].gsub!( /\n{3,}/, "\n\n" )

		return lyrics_data
	end

	def build_suggestions_fetch_data( artist, title, album=nil, year=nil )
		return { "url" => build_google_feeling_lucky_url( artist ) }
	end

	def check_suggestions_page( page_body, artist, title, album=nil, year=nil )
		md = /<title>([^<]+) LYRICS<\/title>/.match( page_body )
		return md ? Strings.normalize( artist ) == Strings.normalize( md[1] ) : false
	end

	def parse_suggestions( url, body, artist, title, album=nil, year=nil )

		body.tr_s!( " \n\r\t", " " )

		suggestions = []

		return suggestions if ( ! (md = /<img src=http:\/\/#{site_host()}\/images\/phone2\.gif border=0><br><br><\/DIV>(.*)<\/lu><br><DIV ALIGN=center><br><img src=http:\/\/#{site_host()}\/images\/phone\.gif/.match( body )) )

		md[1].split( "<li>" ).each() do |entry|
			if ( md = /<a href="([^"]+)"[^>]*>([^<]+) Lyrics<\/a>/.match( entry ) )
				suggestions << { "url"=>"http://#{site_host()}#{md[1]}", "artist"=>artist, "title"=>md[2] }
			end
		end

		return suggestions
	end

end
