# Copyright (C) 2006-2008 by Sergio Pistone
#  sergio_pistone@yahoo.com.ar
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

module Logging

	#def Logging.debug( text )
	#	`kdialog --msgbox #{Strings.shell_quote( text )}`
	#end

	def Logging.setup( log_file, max_lines, old_log_file=nil )
		if ( old_log_file && old_log_file != log_file )
			if ( File.exist?( old_log_file ) && ! File.directory?( old_log_file ) )
				File.delete( old_log_file )
			end
		end
		if ( log_file )
			Logging.truncate( log_file, max_lines )
		end
	end

	def Logging.truncate( log_file, max_lines )
		begin
			file = File.new( log_file, File::RDONLY )
		rescue Errno::ENOENT
			file = File.new( log_file, File::CREAT|File::TRUNC )
		end
		lines = file.read().split( "\n" )
		file.close()
		offset = lines.size() - max_lines
		if ( offset > 0 )
			file = File.new( log_file, File::CREAT|File::TRUNC|File::WRONLY )
			max_lines.times() do |index|
				line = lines[offset + index]
				break if ( ! line )
				file.write( line )
				file.write( "\n" )
			end
			file.close()
		end
	end

	def Logging.reset( log_file )
		output = File.new( log_file, File::CREAT|File::TRUNC )
		output.close()
	end

	def Logging.log( log_file, msg, new_lines=1 )
		output = File.new( log_file, File::CREAT|File::APPEND|File::WRONLY )
		output.write( msg )
		new_lines.times() { output.write( "\n" ) }
		output.close()
	end

end
